# bdm::euni Class Reference

Uniform distributed density on a rectangular support. More...

`#include <exp_family.h>`

List of all members.

## Public Member Functions
double | evallog (const vec &val) const
vec | sample () const
| Returns a sample, from density .
vec | mean () const
| set values of `low` and `high`
vec | variance () const
| return expected variance (not covariance!)
void | from_setting (const Setting &set)
virtual string | to_string ()
| This method returns a basic info about the current instance.
virtual void | to_setting (Setting &set) const
| This method save all the instance properties into the Setting structure.
virtual void | validate ()
| This method TODO.
Constructors
| euni ()
| euni (const vec &low0, const vec &high0)
void | set_parameters (const vec &low0, const vec &high0)
Constructors
Construction of each epdf should support two types of constructors: empty constructor, copy constructor, The following constructors should be supported for convenience: constructor followed by calling `set_parameters()` constructor accepting random variables calling `set_rv()` All internal data structures are constructed as empty. Their values (including sizes) will be set by method `set_parameters()`. This way references can be initialized in constructors.
void | set_parameters (int dim0)
Matematical Operations
virtual mat | sample_m (int N) const
| Returns N samples, from density .
virtual vec | evallog_m (const mat &Val) const
| Compute log-probability of multiple values argument `val`.
virtual vec | evallog_m (const Array< vec > &Avec) const
| Compute log-probability of multiple values argument `val`.
virtual shared_ptr< mpdf > | condition (const RV &rv) const
| Return conditional density on the given RV, the remaining rvs will be in conditioning.
virtual shared_ptr< epdf > | marginal (const RV &rv) const
| Return marginal density on the given RV, the remainig rvs are intergrated out.
virtual void | qbounds (vec &lb, vec &ub, double percentage=0.95) const
| Lower and upper bounds of `percentage` % quantile, returns mean-2*sigma as default.
Connection to other classes
Description of the random quantity via attribute `rv` is optional. For operations such as sampling `rv` does not need to be set. However, for `marginalization` and `conditioning` `rv` has to be set. NB:
void | set_rv (const RV &rv0)
| Name its rv.
bool | isnamed () const
| True if rv is assigned.
const RV & | _rv () const
| Return name (fails when isnamed is false).
Access to attributes
int | dimension () const
| Size of the random variable.
## Protected Attributes
vec | low
| lower bound on support
vec | high
| upper bound on support
vec | distance
| internal
double | nk
| normalizing coefficients
double | lnk
| cache of log( `nk` )
int | dim
| dimension of the random variable
RV | rv
| Description of the random variable.

## Detailed Description

Uniform distributed density on a rectangular support.

## Member Function Documentation

double bdm::euni::evallog | ( | const vec & | val | ) | const`[inline, virtual]`

Compute log-probability of argument `val` In case the argument is out of suport return -Infinity

Reimplemented from bdm::epdf.

References high, lnk, and low.

void bdm::euni::from_setting | ( | const Setting & | set | ) | `[inline, virtual]`

Load from structure with elements:

     { high = [...];          // vector of upper bounds
       low = [...];           // vector of lower bounds
       rv = {class="RV",...}  // description of RV
     }

Reimplemented from bdm::epdf.

References bdm::UI::get(), high, and low.

The documentation for this class was generated from the following file:

- exp_family.h